#include"cola.h"

//#define _CHUJBURY_

#ifdef _CHUJBURY_
void log997(char *s)
{
  fprintf(stderr,"%s\n",s);
}
#endif

void add2env(SE *k,SE *v)
{
  SE *oldtop=topenv;

#ifdef _CHUJBURY_
  log997(strdup("add2env"));
#endif

  topenv=clone(new_cons(new_cons(k,v),oldtop)); /////// ???????
  destroy(oldtop);
}

SE *assoc(SE *k,SE *al)
{

#ifdef _CHUJBURY_
  log997(strdup("assoc"));
#endif

  while(al!=NIL)
    {
      if(eq(head(head(al)),k)) return tail(head(al));      
      al=tail(al);
    }
  return NIL;
}

SE *apply(SE *,SE *,SE *);
SE *evlambda(SE *,SE *,SE *);

SE *eval(SE *e,SE *env)
{

#ifdef _CHUJBURY_
  //  log997(strcat(strdup("eval "),se2str(e)));
  fprintf(stderr,"eval e=%s \n",se2str(e));
#endif

  if(e==NIL) return NIL;
  switch(type(e))
    {
    case NUM:
    case STR:
    case FUN:
    case LAMBDA: return e;
    case SYM: return assoc(e,env);
    case CONS: return apply(eval(head(e),env),tail(e),env);
    }
  return NIL;
}

SE *apply(SE *f,SE *arg,SE *env)
{

#ifdef _CHUJBURY_
  //  log997(strcat(strdup("apply"),se2str(arg)));
  fprintf(stderr,"apply f=%s arg=%s\n",se2str(f),se2str(arg));
#endif

  if(!f) err("apply - nil as function");
  switch(type(f))
    {
    case NUM: err("apply - num as function");
    case STR: err("apply - str as function");
    case CONS:
    case SYM: return apply(eval(f,env),arg,env);
    case FUN: return funv(f)(arg,env);
    case LAMBDA: return evlambda(f,arg,env);
    }
  err("apply broke");
  return NIL; /* notreached */
}

SE *evlambda(SE *lambda,SE *av,SE *env)
{
  SE *v;

#ifdef _CHUJBURY_
  log997(strdup("evlambda"));
#endif

  v=eval(body(lambda),append(append(pair(argl(lambda),evlis(av,env)),
			            bind(lambda)),
		             env));
  return v;
}

void cola_init()
{

#ifdef _CHUJBURY_
  log997(strdup("init"));
#endif

  topenv=NIL;
  gc_init();
  // core language:
  T=new_sym("t");
  add2env(T,T);
  add2env(new_sym("quote"),new_fun(fquote));
  add2env(new_sym("$"),new_fun(feval));
  add2env(new_sym("?"),new_fun(fcond));
  add2env(new_sym("!"),new_fun(flabel));
  add2env(new_sym("^"),new_fun(flambda));
  add2env(new_sym("="),new_fun(feq));
  add2env(new_sym("#"),new_fun(fisnum));
  add2env(new_sym(":?str"),new_fun(fisstr));
  add2env(new_sym("@"),new_fun(fisatom));
  add2env(new_sym(";"),new_fun(fcons));
  add2env(new_sym("."),new_fun(fhead));
  add2env(new_sym(","),new_fun(ftail));
  // arithmetics:
  add2env(new_sym("+"),new_fun(fadd));
  add2env(new_sym("-"),new_fun(fsub));
  add2env(new_sym("*"),new_fun(fmul));
  add2env(new_sym("/"),new_fun(fdiv));
  add2env(new_sym("%"),new_fun(f_mod));
  add2env(new_sym("<"),new_fun(flt));
  add2env(new_sym(">"),new_fun(fgt));
  add2env(new_sym(":abs"),new_fun(fabsol));

  add2env(new_sym(":apd"),new_fun(fapp));
  add2env(new_sym(":rev"),new_fun(frev));
  add2env(new_sym(":map"),new_fun(fmap));
  add2env(new_sym(":evlis"),new_fun(fevlis));
  add2env(new_sym(":pair"),new_fun(fpair));
  add2env(new_sym(":assoc"),new_fun(fassoc));
  add2env(new_sym(":len"),new_fun(flen));
  add2env(new_sym(":ismem"),new_fun(fismem));

  add2env(new_sym(":env"),new_fun(fshowenv));

  add2env(new_sym("^env"),new_fun(flambdaenv));
  add2env(new_sym("^!"),new_fun(flambdalabel));


  add2env(new_sym(":strstr"),new_fun(fstrstr));
  add2env(new_sym(":strcmp"),new_fun(fstrcmp));
  add2env(new_sym(":strcat"),new_fun(fstrcat));
  add2env(new_sym(":strlen"),new_fun(fstrlen));
  add2env(new_sym(":left"),new_fun(fleft));

  add2env(new_sym(":disp"),new_fun(fdisp));
  add2env(new_sym(":read"),new_fun(fread_));
  //  add2env(new_sym(":load"),new_fun(fload));
  add2env(new_sym(":load"),new_fun(fload2)); // to bylo :load2
  add2env(new_sym(":save"),new_fun(fsave));
  add2env(new_sym(":parse"),new_fun(fparse));
  add2env(new_sym(":tostr"),new_fun(ftostr));

  // where to come back when things go wrong:
  bookmark=gc_top();
  setjmp(_kosmos); 
}


// usefull stuff here:

SE *append(SE *a,SE *b)
{

#ifdef _CHUJBURY_
  log997(strdup("append"));
#endif

  if(a==NIL) return b;
  return new_cons(head(a),append(tail(a),b));
}

SE *evlis(SE *l,SE *env)
{

#ifdef _CHUJBURY_
  log997(strdup("evlis"));
#endif

  if(l==NIL) return NIL;
  return new_cons(eval(head(l),env),evlis(tail(l),env));
}

SE *pair(SE *a,SE *b)
{

#ifdef _CHUJBURY_
  log997(strdup("pair"));
#endif

  if(a==NIL) return NIL;
  if(b==NIL) err("pair - list too short");
  return new_cons(new_cons(head(a),head(b)),pair(tail(a),tail(b)));
}

SE *map(SE *f,SE *l,SE *env)
{
#ifdef _CHUJBURY_
  log997(strdup("map"));
#endif

  if(l==NIL) return NIL;
  return new_cons(apply(f,new_cons(head(l),NIL),env),
                  map(f,tail(l),env));
}

SE *reverse(SE *l)
{

#ifdef _CHUJBURY_
  log997(strdup("reverse"));
#endif

  if(isatom(l)) return l;
  return append(reverse(tail(l)),new_cons(head(l),NIL));
}

int len_(SE *l)
{

#ifdef _CHUJBURY_
  log997(strdup("len_"));
#endif

  if(l==NIL) return 0;
  if(isatom(l)) return 1; //
  return 1+len_(tail(l));
}

int ismem(SE *k,SE *l)
{

#ifdef _CHUJBURY_
  log997(strdup("ismem"));
#endif

  while(l!=NIL)
    {
      if(eq(k,head(l))) return 1;
      l=tail(l);
    }
  return 0;
}
