#include"cola.h"

//////////////////////////////
#ifdef _GCTEST_
#include"gctest.h"
#endif
//////////////////////////////

typedef struct gc_node gc_node;
struct gc_node
{
  SE *e;
  gc_node *next;
}*gc_stack;

void gc_init()
{
  gc_stack=NULL;
}

void gc_push(SE *e)
{
  gc_node *n=new(gc_node);
  if(n)
    {
      n->e=e;
      n->next=gc_stack;
      gc_stack=n;
//////////////////////////////
#ifdef _GCTEST_
      gctestpush(e);
#endif      
//////////////////////////////
    }
   else err("gc_push failed");
}

SE *gc_top()
{
  if(gc_stack)
    return gc_stack->e;
  return NIL;
}

void gc_clearto(SE *bookmark)
{
  gc_node *c;
  for(c=gc_stack;c!=NULL && c->e!=bookmark;c=gc_stack)
    {
      gc_stack=c->next;
      switch(type(c->e))
	{
	case LAMBDA: destroy(bind(c->e)); break; //
	case SYM: free(symv(c->e)); break;
	case STR: free(strv(c->e)); break;
	default: break;
	}
//////////////////////////////
#ifdef _GCTEST_
      gctestrem(c->e);
#endif      
//////////////////////////////
      free(c->e);
      free(c);
    }
//////////////////////////////
#ifdef _GCTEST_
  gcreport();
#endif      
//////////////////////////////
}
