typedef struct SE SE;
typedef enum{NUM,SYM,STR,FUN,LAMBDA,CONS}setype;

struct SE
{
  setype type;
  union
  {
    int num;
    char *str;
    SE *(*fun)(SE *,SE *);
    SE *cons[2];
    SE *lambda[3];
  };
};

#define NIL NULL
SE *T;

#define type(S) (S)->type
#define numv(S) (S)->num
#define symv(S) (S)->str
#define strv(S) (S)->str
#define funv(S) (S)->fun
#define head(S) (S)->cons[0]
#define tail(S) (S)->cons[1]
#define argl(S) (S)->lambda[1]
#define bind(S) (S)->lambda[2]
#define body(S) (S)->lambda[3]

#define isatom(S) ((S)==NIL||(S)->type!=CONS)
#define isnum(S) ((S)->type==NUM)
#define isstr(S) ((S)->type==STR)

SE *new_num(int);
SE *new_sym(char *);
SE *new_str(char *);
SE *new_fun(SE *(*fun)(SE *,SE *));
SE *new_lambda(SE *,SE *,SE *);
SE *new_cons(SE *,SE *);

int eq(SE *,SE *);

SE *clone(SE *);
void destroy(SE *);

void gc_init();
void gc_push(SE *);
void gc_clearto(SE *);
SE *gc_top();
